package com.zanxiang.manage.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.common.utils.bean.BeanUtils;
import com.zanxiang.manage.domain.vo.GameChoiceVO;
import com.zanxiang.manage.service.GameService;
import com.zanxiang.mybatis.entity.Game;
import com.zanxiang.mybatis.mapper.GameMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author : lingfeng
 * @time : 2022-06-24
 * @description : 游戏逻辑
 */
@Slf4j
@Service
public class GameServiceImpl extends ServiceImpl<GameMapper, Game> implements GameService {

    /**
     * 游戏选择列表查询
     *
     * @return : 返回所有游戏信息
     */
    @Override
    public List<GameChoiceVO> choiceList() {
        List<Game> gameList = super.list(new LambdaQueryWrapper<Game>().select(Game::getId, Game::getName));
        return BeanUtils.copyList(gameList, GameChoiceVO.class);
    }
}
