package com.zanxiang.manage.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zanxiang.manage.domain.dto.UserDTO;
import com.zanxiang.mybatis.entity.User;

import java.util.List;

/**
 * @author : lingfeng
 * @time : 2022-06-08
 * @description : 用户信息
 */
public interface UserService extends IService<User> {

    /**
     * 根据玩家账号或者昵称模糊查询玩家列表
     *
     * @param userName : 玩家账号
     * @param nickname : 玩家昵称
     * @return : 返回玩家信息
     */
    List<UserDTO> getLikeUserNameOrNickName(String userName, String nickname);

    /**
     * 根据用户id查询信息
     *
     * @param userId : 返回用户信息
     * @return : 返回用户信息
     */
    UserDTO getById(Long userId);
}
